#include <rc552.h>
#define MAXRLEN 18

uint8_t in[2];
uint8_t out[2];

//#define RESET_LOW SYS_PORTS_PinClear(PORTS_ID_0, PORT_CHANNEL_A, PORTS_BIT_POS_0);
//#define RESET_HIGH SYS_PORTS_PinSet(PORTS_ID_0, PORT_CHANNEL_A, PORTS_BIT_POS_0);
//#define SS_LOW SYS_PORTS_PinClear(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_15);
//#define SS_HIGH SYS_PORTS_PinSet(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_15);

/////////////////////////////////////////////////////////////////////
//@\FJ[h
//p[^̐Freq_code [IN]FJ[h\bh
// 0x52 =U][ׂ̂Ă14443AJ[h
// 0x26 =X[vԂɂȂĂȂJ[h
// pTagType [OUT]FJ[h^CvR[h
// 0x4400 = Mifare_UltraLight
// 0x0400 = Mifare_OneiS50j
// 0x0200 = Mifare_OneiS70j
// 0x0800 = Mifare_ProiXj
// 0x4403 = Mifare_DESFire
//߂lFMI_OKɕԂ܂
/////////////////////////////////////////////////////////////////////

int8_t PcdRequest(uint8_t req_code, uint8_t *pTagType) {
    int8_t status;
    uint32_t unLen;
    uint8_t ucComMF522Buf[MAXRLEN];

    ClearBitMask(Status2Reg, 0x08); //MFCrypto1On
    WriteRawRC(BitFramingReg, 0x07);
    SetBitMask(TxControlReg, 0x03);

    ucComMF522Buf[0] = req_code;

    status = PcdComMF522(PCD_TRANSCEIVE, ucComMF522Buf, 1, ucComMF522Buf, &unLen);

    if ((status == MI_OK) && (unLen == 0x10)) {
        *pTagType = ucComMF522Buf[0];
        *(pTagType + 1) = ucComMF522Buf[1];
    } else {
        status = MI_ERR;
    }

    return status;
}

/////////////////////////////////////////////////////////////////////
//@\FA`RW
//p[^FpSnr [OUT]FJ[hVAԍA4oCg
//߂lFMI_OKɕԂ܂
/////////////////////////////////////////////////////////////////////  

int8_t PcdAnticoll(uint8_t *pSnr) {
    int8_t status;
    uint8_t i, snr_check = 0;
    uint32_t unLen;
    uint8_t ucComMF522Buf[MAXRLEN];

    ClearBitMask(Status2Reg, 0x08);
    WriteRawRC(BitFramingReg, 0x00);
    ClearBitMask(CollReg, 0x80);

    ucComMF522Buf[0] = PICC_ANTICOLL1;
    ucComMF522Buf[1] = 0x20;

    status = PcdComMF522(PCD_TRANSCEIVE, ucComMF522Buf, 2, ucComMF522Buf, &unLen);

    if (status == MI_OK) {
        for (i = 0; i < 4; i++) {
            *(pSnr + i) = ucComMF522Buf[i];
            snr_check ^= ucComMF522Buf[i];
        }
        if (snr_check != ucComMF522Buf[i]) {
            status = MI_ERR;
        }
    }

    SetBitMask(CollReg, 0x80);
    return status;
}

/////////////////////////////////////////////////////////////////////
//@\FIJ[h
//p[^FpSnr [IN]FJ[h̃VAԍA4oCg
//߂lFMI_OKɕԂ܂
/////////////////////////////////////////////////////////////////////

int8_t PcdSelect(uint8_t *pSnr) {
    int8_t status;
    uint8_t i;
    uint32_t unLen;
    uint8_t ucComMF522Buf[MAXRLEN];

    ucComMF522Buf[0] = PICC_ANTICOLL1;
    ucComMF522Buf[1] = 0x70;
    ucComMF522Buf[6] = 0;
    for (i = 0; i < 4; i++) {
        ucComMF522Buf[i + 2] = *(pSnr + i);
        ucComMF522Buf[6] ^= *(pSnr + i);
    }
    CalulateCRC(ucComMF522Buf, 7, &ucComMF522Buf[7]);

    ClearBitMask(Status2Reg, 0x08);

    status = PcdComMF522(PCD_TRANSCEIVE, ucComMF522Buf, 9, ucComMF522Buf, &unLen);

    if ((status == MI_OK) && (unLen == 0x18)) {
        status = MI_OK;
    } else {
        status = MI_ERR;
    }

    return status;
}

/////////////////////////////////////////////////////////////////////
//@\FJ[h̃pX[hmF
//p[^Fauth_mode [IN]FpX[hmF[h
// 0x60 =؂
// 0x61 = BL[mF
// addr [IN]FubNAhX
// pKey [IN]FpX[h
// pSnr [IN]FJ[hVAԍA4oCg
//߂lFMI_OKɕԂ܂
/////////////////////////////////////////////////////////////////////               

int8_t PcdAuthState(uint8_t auth_mode, uint8_t addr, uint8_t *pKey, uint8_t *pSnr) {
    int8_t status;
    uint32_t unLen;
    uint8_t i, ucComMF522Buf[MAXRLEN];

    ucComMF522Buf[0] = auth_mode;
    ucComMF522Buf[1] = addr;
    for (i = 0; i < 6; i++) {
        ucComMF522Buf[i + 2] = *(pKey + i);
    }
    for (i = 0; i < 6; i++) {
        ucComMF522Buf[i + 8] = *(pSnr + i);
    }
    //   memcpy(&ucComMF522Buf[2], pKey, 6); 
    //   memcpy(&ucComMF522Buf[8], pSnr, 4); 

    status = PcdComMF522(PCD_AUTHENT, ucComMF522Buf, 12, ucComMF522Buf, &unLen);
    if ((status != MI_OK) || (!(ReadRawRC(Status2Reg) & 0x08))) {
        status = MI_ERR;
    }

    return status;
}

/////////////////////////////////////////////////////////////////////
//@\FM1J[hf[^ǂݍ
//p[^̐Faddr [IN]FubNAhX
// pData [OUT]Fǂݏof[^A16oCg
//߂lFMI_OKɕԂ܂
///////////////////////////////////////////////////////////////////// 

int8_t PcdRead(uint8_t addr, uint8_t *pData) {
    int8_t status;
    uint32_t unLen;
    uint8_t i, ucComMF522Buf[MAXRLEN];

    ucComMF522Buf[0] = PICC_READ;
    ucComMF522Buf[1] = addr;
    CalulateCRC(ucComMF522Buf, 2, &ucComMF522Buf[2]);

    status = PcdComMF522(PCD_TRANSCEIVE, ucComMF522Buf, 4, ucComMF522Buf, &unLen);
    if ((status == MI_OK) && (unLen == 0x90))
        //   {   memcpy(pData, ucComMF522Buf, 16);   }
    {
        for (i = 0; i < 16; i++) {
            *(pData + i) = ucComMF522Buf[i];
        }
    } else {
        status = MI_ERR;
    }

    return status;
}

/////////////////////////////////////////////////////////////////////
//@\FM1J[hɃf[^
//p[^̐Faddr [IN]FubNAhX
// pData [IN]F܂ꂽf[^A16oCg
//߂lFMI_OKɕԂ܂
/////////////////////////////////////////////////////////////////////                  

int8_t PcdWrite(uint8_t addr, uint8_t *pData) {
    int8_t status;
    uint32_t unLen;
    uint8_t i, ucComMF522Buf[MAXRLEN];

    ucComMF522Buf[0] = PICC_WRITE;
    ucComMF522Buf[1] = addr;
    CalulateCRC(ucComMF522Buf, 2, &ucComMF522Buf[2]);

    status = PcdComMF522(PCD_TRANSCEIVE, ucComMF522Buf, 4, ucComMF522Buf, &unLen);

    if ((status != MI_OK) || (unLen != 4) || ((ucComMF522Buf[0] & 0x0f) != 0x0a)) {
        status = MI_ERR;
    }

    if (status == MI_OK) {
        //memcpy(ucComMF522Buf, pData, 16);
        for (i = 0; i < 16; i++) {
            ucComMF522Buf[i] = *(pData + i);
        }
        CalulateCRC(ucComMF522Buf, 16, &ucComMF522Buf[16]);

        status = PcdComMF522(PCD_TRANSCEIVE, ucComMF522Buf, 18, ucComMF522Buf, &unLen);
        if ((status != MI_OK) || (unLen != 4) || ((ucComMF522Buf[0] & 0x0f) != 0x0a)) {
            status = MI_ERR;
        }
    }

    return status;
}

/////////////////////////////////////////////////////////////////////
//@\F`[WobNƍď[d
//p[^Fdd_mode [IN]FR}h[h
// 0xc0 =`[WobN
// 0xc1 =[d
// addr [IN]FEHbgAhX
// pValue [IN]F4oCg̑ijlB
//߂lFMI_OKɕԂ܂
/////////////////////////////////////////////////////////////////////                 

int8_t PcdValue(uint8_t dd_mode, uint8_t addr, uint8_t *pValue) {
    int8_t status;
    uint32_t unLen;
    uint8_t i, ucComMF522Buf[MAXRLEN];

    ucComMF522Buf[0] = dd_mode;
    ucComMF522Buf[1] = addr;
    CalulateCRC(ucComMF522Buf, 2, &ucComMF522Buf[2]);

    status = PcdComMF522(PCD_TRANSCEIVE, ucComMF522Buf, 4, ucComMF522Buf, &unLen);

    if ((status != MI_OK) || (unLen != 4) || ((ucComMF522Buf[0] & 0x0f) != 0x0a)) {
        status = MI_ERR;
    }

    if (status == MI_OK) {
        // memcpy(ucComMF522Buf, pValue, 4);
        for (i = 0; i < 16; i++) {
            ucComMF522Buf[i] = *(pValue + i);
        }
        CalulateCRC(ucComMF522Buf, 4, &ucComMF522Buf[4]);
        unLen = 0;
        status = PcdComMF522(PCD_TRANSCEIVE, ucComMF522Buf, 6, ucComMF522Buf, &unLen);
        if (status != MI_ERR) {
            status = MI_OK;
        }
    }

    if (status == MI_OK) {
        ucComMF522Buf[0] = PICC_TRANSFER;
        ucComMF522Buf[1] = addr;
        CalulateCRC(ucComMF522Buf, 2, &ucComMF522Buf[2]);

        status = PcdComMF522(PCD_TRANSCEIVE, ucComMF522Buf, 4, ucComMF522Buf, &unLen);

        if ((status != MI_OK) || (unLen != 4) || ((ucComMF522Buf[0] & 0x0f) != 0x0a)) {
            status = MI_ERR;
        }
    }
    return status;
}

/////////////////////////////////////////////////////////////////////
//@\FobNAbvEHbg
//p[^̐Fsourceaddr [IN]FMAhX
// goaladdr [IN]F^[QbgAhX
//߂lFMI_OKɕԂ܂
/////////////////////////////////////////////////////////////////////

int8_t PcdBakValue(uint8_t sourceaddr, uint8_t goaladdr) {
    int8_t status;
    uint32_t unLen;
    uint8_t ucComMF522Buf[MAXRLEN];

    ucComMF522Buf[0] = PICC_RESTORE;
    ucComMF522Buf[1] = sourceaddr;
    CalulateCRC(ucComMF522Buf, 2, &ucComMF522Buf[2]);

    status = PcdComMF522(PCD_TRANSCEIVE, ucComMF522Buf, 4, ucComMF522Buf, &unLen);

    if ((status != MI_OK) || (unLen != 4) || ((ucComMF522Buf[0] & 0x0f) != 0x0a)) {
        status = MI_ERR;
    }

    if (status == MI_OK) {
        ucComMF522Buf[0] = 0;
        ucComMF522Buf[1] = 0;
        ucComMF522Buf[2] = 0;
        ucComMF522Buf[3] = 0;
        CalulateCRC(ucComMF522Buf, 4, &ucComMF522Buf[4]);

        status = PcdComMF522(PCD_TRANSCEIVE, ucComMF522Buf, 6, ucComMF522Buf, &unLen);
        if (status != MI_ERR) {
            status = MI_OK;
        }
    }

    if (status != MI_OK) {
        return MI_ERR;
    }

    ucComMF522Buf[0] = PICC_TRANSFER;
    ucComMF522Buf[1] = goaladdr;

    CalulateCRC(ucComMF522Buf, 2, &ucComMF522Buf[2]);

    status = PcdComMF522(PCD_TRANSCEIVE, ucComMF522Buf, 4, ucComMF522Buf, &unLen);

    if ((status != MI_OK) || (unLen != 4) || ((ucComMF522Buf[0] & 0x0f) != 0x0a)) {
        status = MI_ERR;
    }

    return status;
}


/////////////////////////////////////////////////////////////////////
//@\FR}hJ[hX[vԂɂȂ
//߂lFMI_OKɕԂ܂
/////////////////////////////////////////////////////////////////////

int8_t PcdHalt(void) {
//    int8_t status;
    uint32_t unLen;
    uint8_t ucComMF522Buf[MAXRLEN];

    ucComMF522Buf[0] = PICC_HALT;
    ucComMF522Buf[1] = 0;
    CalulateCRC(ucComMF522Buf, 2, &ucComMF522Buf[2]);

    //status = 
            PcdComMF522(PCD_TRANSCEIVE, ucComMF522Buf, 4, ucComMF522Buf, &unLen);

    return MI_OK;
}

/////////////////////////////////////////////////////////////////////
//MF522CRC16֐vZ
/////////////////////////////////////////////////////////////////////

void CalulateCRC(uint8_t *pIndata, uint8_t len, uint8_t *pOutData) {
    uint8_t i, n;

    ClearBitMask(DivIrqReg, 0x04);
    WriteRawRC(CommandReg, PCD_IDLE);
    SetBitMask(FIFOLevelReg, 0x80);
    for (i = 0; i < len; i++) {
        WriteRawRC(FIFODataReg, *(pIndata + i));
    }
    WriteRawRC(CommandReg, PCD_CALCCRC);
    i = 0xff;
    do {
        n = ReadRawRC(DivIrqReg);
        i--;
    }    while ((i != 0) && !(n & 0x04));
    pOutData[0] = ReadRawRC(CRCResultRegL);
    pOutData[1] = ReadRawRC(CRCResultRegM);
}

/////////////////////////////////////////////////////////////////////
//@\FZbgRC522
//߂lFMI_OKɕԂ܂
/////////////////////////////////////////////////////////////////////

int8_t PcdReset(void) {
    // see https://www.microchip.com/forums/m854818.aspx
    //SPI1CONbits.MSSEN=1;//automatically output to ss1(out)

    RESET_Set();
    Delay10us(10);
    RESET_Clear(); //reset
    Delay10us(20); //100 us at least for reset
    RESET_Set();
    Delay10us(10);

    SS_Set();
    
    WriteRawRC(CommandReg, PCD_RESETPHASE); //0x0f Soft Reset
    Delay10us(1000);

    WriteRawRC(ModeReg, 0x3d); //MifareJ[hƂ̒ʐMACRC Preset = 0x6363
    WriteRawRC(TReloadRegL, 30);
    WriteRawRC(TReloadRegH, 0);
    WriteRawRC(TModeReg, 0x8d); //Tauto=1; f(Timer) = 6.78MHz/TPreScaler
    WriteRawRC(TPrescalerReg, 0x3e); //TModeReg[3..0] + TPrescalerReg

    WriteRawRC(TxAutoReg, 0x40); //100%ASK YTS adds this
    //WriteRawRC(RFCfgReg, 0x7f );     //RxGain = 48dB YTS

    return MI_OK;
}

/////////////////////////////////////////////////////////////////////
//@\FRC522WX^ǂݍ
//p[^FAddress [IN]FWX^̃AhX
//߂lFǂݎl
/////////////////////////////////////////////////////////////////////

uint8_t ReadRawRC(uint8_t Address) {

    SS_Clear();
    
    out[0] = ((Address << 1) & 0x7e) | 0x80;
    out[1] = 0x00;

    SPI1_WriteRead (&out, 2, &in, 2);

    SS_Set();
    return in[1];
}

/////////////////////////////////////////////////////////////////////
//@\FRC522WX^
//p[^FAddress [IN]FWX^̃AhX
//l[IN]F܂ꂽl
/////////////////////////////////////////////////////////////////////

void WriteRawRC(uint8_t Address, uint8_t value) {

    SS_Clear();
    
    out[0] = (Address << 1) & 0x7e;
    out[1] = value;

    SPI1_WriteRead (&out, 2, &in, 2);

        SS_Set();
}

/////////////////////////////////////////////////////////////////////
//@\FRC522WX^rbgZbg
//p[^̐Freg [IN]FWX^AhX
//}XN[IN]Fݒl
/////////////////////////////////////////////////////////////////////

void SetBitMask(uint8_t reg, uint8_t mask) {
    int8_t tmp = 0x0;

    tmp = ReadRawRC(reg);
    WriteRawRC(reg, tmp | mask); // set bit mask
}

/////////////////////////////////////////////////////////////////////
//@\FRC522WX^̃rbgNA
//p[^̐Freg [IN]FWX^AhX
//}XN[IN]FlNA
/////////////////////////////////////////////////////////////////////

void ClearBitMask(uint8_t reg, uint8_t mask) {
    int8_t tmp = 0x0;

    tmp = ReadRawRC(reg);
    WriteRawRC(reg, tmp & ~mask); // clear bit mask
}

/////////////////////////////////////////////////////////////////////
//@\FRC522J[hISO14443J[hɂʐM
//p[^̐FR}h[IN]FRC522R}h[h
// pInData [IN]FRC522oRŃJ[hɑMꂽf[^
// InLenByte [IN]FMf[^̃oCg
// pOutData [OUT]FMJ[hԋpf[^
// * pOutLenBit [OUT]Ff[^̃rbgԂ
/////////////////////////////////////////////////////////////////////

int8_t PcdComMF522(uint8_t Command,
        uint8_t *pInData,
        uint8_t InLenByte,
        uint8_t *pOutData,
        uint32_t *pOutLenBit) {
    int8_t status = MI_ERR;
    uint8_t irqEn = 0x00;
    uint8_t waitFor = 0x00;
    uint8_t lastBits;
    uint8_t n;
    uint32_t i;

    switch (Command) {
        case PCD_AUTHENT:
            irqEn = 0x12;
            waitFor = 0x10;
            break;
        case PCD_TRANSCEIVE:
            irqEn = 0x77;
            waitFor = 0x30;
            break;
        default:
            break;
    }

    WriteRawRC(ComIEnReg, irqEn | 0x80);
    ClearBitMask(ComIrqReg, 0x80);
    WriteRawRC(CommandReg, PCD_IDLE);
    SetBitMask(FIFOLevelReg, 0x80);

    for (i = 0; i < InLenByte; i++) {
        WriteRawRC(FIFODataReg, pInData[i]);
    }
    WriteRawRC(CommandReg, Command);

    if (Command == PCD_TRANSCEIVE) {
        SetBitMask(BitFramingReg, 0x80);
    }

    i = 0xffff; //1800;//600;//NbNgɂ΁AM1J[h𓮍삳邽߂̍ő҂Ԃ25ms
    do {
        n = ReadRawRC(ComIrqReg);
        i--;
    }    while ((i != 0) && !(n & 0x01) && !(n & waitFor));
    ClearBitMask(BitFramingReg, 0x80);

    if (i != 0) {
        if (!(ReadRawRC(ErrorReg) & 0x1b)) {
            status = MI_OK;
            if (n & irqEn & 0x01) {
                status = MI_NOTAGERR;
            }
            if (Command == PCD_TRANSCEIVE) {
                n = ReadRawRC(FIFOLevelReg);
                lastBits = ReadRawRC(ControlReg) & 0x07;
                if (lastBits) {
                    *pOutLenBit = (n - 1)*8 + lastBits;
                } else {
                    *pOutLenBit = n * 8;
                }
                if (n == 0) {
                    n = 1;
                }
                if (n > MAXRLEN) {
                    n = MAXRLEN;
                }
                for (i = 0; i < n; i++) {
                    pOutData[i] = ReadRawRC(FIFODataReg);
                }
            }
        } else {
            status = MI_ERR;
        }

    }


    SetBitMask(ControlReg, 0x80); // stop timer now
    WriteRawRC(CommandReg, PCD_IDLE);
    return status;
}

/////////////////////////////////////////////////////////////////////
//AeiJ
//i`Ahx`[N邩Vbg_E܂łɏȂƂ1ms̎ԂKvł
/////////////////////////////////////////////////////////////////////

void PcdAntennaOn() {
    uint8_t i;

    i = ReadRawRC(TxControlReg);
    if (!(i & 0x03)) {
        SetBitMask(TxControlReg, 0x03);
    }
}


/////////////////////////////////////////////////////////////////////
//AeiItɂ
/////////////////////////////////////////////////////////////////////

void PcdAntennaOff() {
    ClearBitMask(TxControlReg, 0x03);
}


//************************************************************

void DelayMs(unsigned short int ms) {
    uint8_t i;
    while (ms--) {
        i = 4;
        while (i--) {
            Delay10us(25);
        }
    }
}

void Delay10us(unsigned long dwCount) {
    volatile unsigned long _dcnt;

    _dcnt = dwCount * ((unsigned long) (0.00001 / (1.0 / SYS_TIME_CPU_CLOCK_FREQUENCY) / 10));
    while (_dcnt--) {
        Nop();
        Nop();
        Nop();
    }
}

//******************************************************************************
